View Issue Details

IDProjectCategoryView StatusLast Update
0038136FPCCompilerpublic2020-12-29 14:59
ReporterJ. Gareth Moreton Assigned ToYuriy Sydorov  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
Platformi386-win32OSMicrosoft Windows 
Product Version3.3.1 
Fixed in Version3.3.1 
Summary0038136: i386-win32 compiler build crashes at WPO stage under -CriotR
DescriptionWhen building the compiler under -CriotR options on i386-win32, it crashes with an access violation at the whole-program optimization stage.
Steps To ReproduceWhen under win64, I do something akin to: make clean all FPC=C:\FPC\3.2.0\bin\i386-win32\fpc CPU_TARGET=i386 OS_TARGET=win32 OPT="-CriotR"

Observe a compiler exception while running ppcwpo1.exe (see Additional Information for an example log):
Additional Information...
C:/Users/garet/Documents/programming/fpc/compiler/ppcwpo1.exe -Ur -Xs -O2 -n -Fi../inc -Fi../i386 -Fi../win -FE. -FUC:/Users/garet/Documents/programming/fpc/rtl/units/i386-win32 -CriotR -DD2020/11/27 -Owdevirtcalls,optvmts -FwC:/Users/garet/Documents/programming/fpc/compiler/pp2.wpo -di386 -dRELEASE -Fi../objpas/sysutils -Fi../objpas/classes -Fu../i386 -I../objpas -I../win/wininc -Fu../win/wininc -Fu../win -I../inc -Fu../inc -Fu../objpas buildrtl
Error: Compilation raised exception internally
An unhandled exception occurred at $00467DFF:
EAccessViolation: Access violation
  $00467DFF

make[6]: *** [buildrtl.ppu] Error 217
make[6]: Leaving directory `C:/Users/garet/Documents/programming/fpc/rtl/win32'
make[5]: *** [win32_all] Error 2
make[5]: Leaving directory `C:/Users/garet/Documents/programming/fpc/rtl'
make[4]: *** [rtl] Error 2
make[4]: Leaving directory `C:/Users/garet/Documents/programming/fpc/compiler'
make[3]: *** [wpocycle] Error 2
make[3]: Leaving directory `C:/Users/garet/Documents/programming/fpc/compiler'
make[2]: *** [cycle] Error 2
make[2]: Leaving directory `C:/Users/garet/Documents/programming/fpc/compiler'
make[1]: *** [compiler_cycle] Error 2
make[1]: Leaving directory `C:/Users/garet/Documents/programming/fpc'
make: *** [build-stamp.i386-win32] Error 2

----

Additional debugging information suggests the exception might be occurring under a call to FreeInstance.
TagsNo tags attached.
Fixed in Revisionr47749
FPCOldBugId
FPCTarget-
Attached Files

Relationships

has duplicate 0036660 resolvedJonas Maebe "make all" crashes on i386-win32 when OPT="-CriotR" is specified. 

Activities

J. Gareth Moreton

2020-12-11 01:02

developer   ~0127529

No longer crashes as of r47749 thanks to Yuriy's fix.

Issue History

Date Modified Username Field Change
2020-11-27 05:52 J. Gareth Moreton New Issue
2020-12-11 01:02 J. Gareth Moreton Status new => resolved
2020-12-11 01:02 J. Gareth Moreton Resolution open => fixed
2020-12-11 01:02 J. Gareth Moreton Fixed in Version => 3.3.1
2020-12-11 01:02 J. Gareth Moreton Fixed in Revision => r47749
2020-12-11 01:02 J. Gareth Moreton FPCTarget => -
2020-12-11 01:02 J. Gareth Moreton Note Added: 0127529
2020-12-29 11:51 Jonas Maebe Assigned To => Yuriy Sydorov
2020-12-29 14:59 Jonas Maebe Relationship added has duplicate 0036660